summaryrefslogtreecommitdiff
path: root/sys-apps
diff options
context:
space:
mode:
authorBlackNoxis <steven.darklight@gmail.com>2015-05-12 22:50:09 +0300
committerBlackNoxis <steven.darklight@gmail.com>2015-05-12 22:50:09 +0300
commitb378a551a1a739c5e1f55677c32f57b36f1bb1df (patch)
treecdcf585117c6e6026b4d2aac6dc22604fcf749d2 /sys-apps
parentc5385038e6c212947826492fa74543e3189c011e (diff)
[systemd] added new ebuilds for specific things in systemd
Diffstat (limited to 'sys-apps')
-rw-r--r--sys-apps/systemd/Manifest4
-rw-r--r--sys-apps/systemd/files/215-0001-always-check-for-__BYTE_ORDER-__BIG_ENDIAN-when-chec.patch116
-rw-r--r--sys-apps/systemd/files/215-0002-endian-explicitly-include-endian.h-wherever-we-want-.patch53
-rw-r--r--sys-apps/systemd/files/215-0003-udev-exclude-MD-from-block-device-ownership-event-lo.patch54
-rw-r--r--sys-apps/systemd/files/216-lz4-build.patch19
-rw-r--r--sys-apps/systemd/files/216-tmpfiles-setup-dev.patch21
-rw-r--r--sys-apps/systemd/files/blacklist-14648
-rw-r--r--sys-apps/systemd/metadata.xml20
-rw-r--r--sys-apps/systemd/systemd-208-r3.ebuild394
-rw-r--r--sys-apps/systemd/systemd-215-r3.ebuild521
-rw-r--r--sys-apps/systemd/systemd-216-r3.ebuild526
11 files changed, 1776 insertions, 0 deletions
diff --git a/sys-apps/systemd/Manifest b/sys-apps/systemd/Manifest
new file mode 100644
index 00000000..30f6ac0c
--- /dev/null
+++ b/sys-apps/systemd/Manifest
@@ -0,0 +1,4 @@
+DIST systemd-208-r1.tar.xz 2382904 SHA256 aa64fa864466fd5727005c55d61c092828b94b4f857272c0b503695022146390 SHA512 c21989b747f5e73ba2311919e1ae558132e4ab2e0d8715c25f51e5e90069e147a52e04280c736ecca6b675af7d79def576171a9b08aaeda45fcd52bcdca011cb WHIRLPOOL e86fdbf96c75c4c94c9507900a5696ff811f5439e0cb45bdc765dc42c62a855c9d2e7d3414df7ec7e18013d937c9148e42c861d0e28e8b4c2fabebd234fbee03
+DIST systemd-215.tar.xz 2888652 SHA256 ce76a3c05e7d4adc806a3446a5510c0c9b76a33f19adc32754b69a0945124505 SHA512 58de0bf7c43c309c2f8e4b7af16b46608a4ea39cbb280496fe5d43d76ea25545484f4ef62efce18be487c69134e4a038d8787f2c262484f92f7fc6feb3ae2f11 WHIRLPOOL 07389822b9f09cd91f360f3cbdcd0b5bf46ba1750dd1a4ad44fd2813436ef40b447b954d33582ffe83aebde618ecbeac4d2f3231d8afbf3975caf84f52b1053a
+DIST systemd-216.tar.xz 3612960 SHA256 945d3db7d840d6ffe98aa68394428e13317161ae79905397faab6671619728f3 SHA512 f4eee6664368168eafd61939f1355ac21c7eeecce6247de98ef36f40bb6a942d12c006ced4ee15f3d8f11699c194990222d5a5115b45f2aa81f2a1abafebbdd2 WHIRLPOOL 505e09b55209a4f9d8cec077970571b2e1298e8db02946a6c79df139dece9d1a08e46c86ef6c8053274abfd46c9a5ea09157f5bc9dc1f7461322c596e84ef494
+DIST systemd-gentoo-patchset-208_p19.tar.bz2 7351 SHA256 3fce1d7ff628b0f49d4bf45eb7beb7d3b4a45c219464be47e4b04e5e16ace335 SHA512 d2ee48a46a8dc097f41d23c58c2c8f40841b42ce175d633ba0090543164c353449a911c5f314b1d1aa7937e51b97cc2608aa4590f0ff56140b42108b0e76a2e8 WHIRLPOOL 934fd88ee12ed72709e0b7aabe01f9e21417480156049af80eaa5413d50726aa49abc03e756bdeff45a4f82decaafa1f76539f16b2319e3c42a0a593f2096417
diff --git a/sys-apps/systemd/files/215-0001-always-check-for-__BYTE_ORDER-__BIG_ENDIAN-when-chec.patch b/sys-apps/systemd/files/215-0001-always-check-for-__BYTE_ORDER-__BIG_ENDIAN-when-chec.patch
new file mode 100644
index 00000000..b29c10de
--- /dev/null
+++ b/sys-apps/systemd/files/215-0001-always-check-for-__BYTE_ORDER-__BIG_ENDIAN-when-chec.patch
@@ -0,0 +1,116 @@
+From 28f6bb18cdea297164763db94e2366ca4857c9c7 Mon Sep 17 00:00:00 2001
+From: Lennart Poettering <lennart@poettering.net>
+Date: Fri, 11 Jul 2014 15:56:16 +0200
+Subject: [PATCH 1/2] always check for __BYTE_ORDER == __BIG_ENDIAN when
+ checking for endianess
+
+Let's always stick to glibc's way to determine byte order, and not mix
+autoconf-specific checks with gcc checks.
+---
+ src/shared/architecture.h | 12 ++++++------
+ src/shared/gpt.h | 4 ++--
+ src/shared/time-dst.c | 6 +++---
+ 3 files changed, 11 insertions(+), 11 deletions(-)
+
+diff --git a/src/shared/architecture.h b/src/shared/architecture.h
+index 4821d5d..58e97e5 100644
+--- a/src/shared/architecture.h
++++ b/src/shared/architecture.h
+@@ -80,7 +80,7 @@ Architecture uname_architecture(void);
+ # define native_architecture() ARCHITECTURE_X86
+ # define LIB_ARCH_TUPLE "i386-linux-gnu"
+ #elif defined(__powerpc64__)
+-# if defined(WORDS_BIGENDIAN)
++# if __BYTE_ORDER == __BIG_ENDIAN
+ # define native_architecture() ARCHITECTURE_PPC64
+ # define LIB_ARCH_TUPLE "ppc64-linux-gnu"
+ # else
+@@ -88,7 +88,7 @@ Architecture uname_architecture(void);
+ # error "Missing LIB_ARCH_TUPLE for PPC64LE"
+ # endif
+ #elif defined(__powerpc__)
+-# if defined(WORDS_BIGENDIAN)
++# if __BYTE_ORDER == __BIG_ENDIAN
+ # define native_architecture() ARCHITECTURE_PPC
+ # define LIB_ARCH_TUPLE "powerpc-linux-gnu"
+ # else
+@@ -117,7 +117,7 @@ Architecture uname_architecture(void);
+ # define native_architecture() ARCHITECTURE_SPARC
+ # define LIB_ARCH_TUPLE "sparc-linux-gnu"
+ #elif defined(__mips64__)
+-# if defined(WORDS_BIGENDIAN)
++# if __BYTE_ORDER == __BIG_ENDIAN
+ # define native_architecture() ARCHITECTURE_MIPS64
+ # error "Missing LIB_ARCH_TUPLE for MIPS64"
+ # else
+@@ -125,7 +125,7 @@ Architecture uname_architecture(void);
+ # error "Missing LIB_ARCH_TUPLE for MIPS64_LE"
+ # endif
+ #elif defined(__mips__)
+-# if defined(WORDS_BIGENDIAN)
++# if __BYTE_ORDER == __BIG_ENDIAN
+ # define native_architecture() ARCHITECTURE_MIPS
+ # define LIB_ARCH_TUPLE "mips-linux-gnu"
+ # else
+@@ -136,7 +136,7 @@ Architecture uname_architecture(void);
+ # define native_architecture() ARCHITECTURE_ALPHA
+ # define LIB_ARCH_TUPLE "alpha-linux-gnu"
+ #elif defined(__aarch64__)
+-# if defined(WORDS_BIGENDIAN)
++# if __BYTE_ORDER == __BIG_ENDIAN
+ # define native_architecture() ARCHITECTURE_ARM64_BE
+ # define LIB_ARCH_TUPLE "aarch64_be-linux-gnu"
+ # else
+@@ -144,7 +144,7 @@ Architecture uname_architecture(void);
+ # define LIB_ARCH_TUPLE "aarch64-linux-gnu"
+ # endif
+ #elif defined(__arm__)
+-# if defined(WORDS_BIGENDIAN)
++# if __BYTE_ORDER == __BIG_ENDIAN
+ # define native_architecture() ARCHITECTURE_ARM_BE
+ # if defined(__ARM_EABI__)
+ # if defined(__ARM_PCS_VFP)
+diff --git a/src/shared/gpt.h b/src/shared/gpt.h
+index 64090e0..278940b 100644
+--- a/src/shared/gpt.h
++++ b/src/shared/gpt.h
+@@ -42,10 +42,10 @@
+ # define GPT_ROOT_NATIVE GPT_ROOT_X86
+ #endif
+
+-#if defined(__aarch64__) && !defined(WORDS_BIGENDIAN)
++#if defined(__aarch64__) && (__BYTE_ORDER != __BIG_ENDIAN)
+ # define GPT_ROOT_NATIVE GPT_ROOT_ARM_64
+ # define GPT_ROOT_SECONDARY GPT_ROOT_ARM
+-#elif defined(__arm__) && !defined(WORDS_BIGENDIAN)
++#elif defined(__arm__) && (__BYTE_ORDER != __BIG_ENDIAN)
+ # define GPT_ROOT_NATIVE GPT_ROOT_ARM
+ #endif
+
+diff --git a/src/shared/time-dst.c b/src/shared/time-dst.c
+index ceca2fa..6195b11 100644
+--- a/src/shared/time-dst.c
++++ b/src/shared/time-dst.c
+@@ -207,8 +207,8 @@ read_again:
+ if (type_idxs[i] >= num_types)
+ return -EINVAL;
+
+- if (BYTE_ORDER == BIG_ENDIAN ? sizeof(time_t) == 8 && trans_width == 4
+- : sizeof(time_t) == 4 || trans_width == 4) {
++ if (__BYTE_ORDER == __BIG_ENDIAN ? sizeof(time_t) == 8 && trans_width == 4
++ : sizeof(time_t) == 4 || trans_width == 4) {
+ /* Decode the transition times, stored as 4-byte integers in
+ network (big-endian) byte order. We work from the end of
+ the array so as not to clobber the next element to be
+@@ -216,7 +216,7 @@ read_again:
+ i = num_transitions;
+ while (i-- > 0)
+ transitions[i] = decode((char *)transitions + i * 4);
+- } else if (BYTE_ORDER != BIG_ENDIAN && sizeof(time_t) == 8) {
++ } else if (__BYTE_ORDER != __BIG_ENDIAN && sizeof(time_t) == 8) {
+ /* Decode the transition times, stored as 8-byte integers in
+ network (big-endian) byte order. */
+ for (i = 0; i < num_transitions; ++i)
+--
+1.8.5.5
+
diff --git a/sys-apps/systemd/files/215-0002-endian-explicitly-include-endian.h-wherever-we-want-.patch b/sys-apps/systemd/files/215-0002-endian-explicitly-include-endian.h-wherever-we-want-.patch
new file mode 100644
index 00000000..71acac1b
--- /dev/null
+++ b/sys-apps/systemd/files/215-0002-endian-explicitly-include-endian.h-wherever-we-want-.patch
@@ -0,0 +1,53 @@
+From 2281422746c00d2803911f2b4699eee6bc87ee04 Mon Sep 17 00:00:00 2001
+From: Lennart Poettering <lennart@poettering.net>
+Date: Fri, 11 Jul 2014 16:13:13 +0200
+Subject: [PATCH 2/2] endian: explicitly include endian.h wherever we want to
+ use __BYTE_ORDER
+
+---
+ src/libsystemd/sd-bus/bus-protocol.h | 1 +
+ src/shared/architecture.h | 2 ++
+ src/shared/gpt.h | 2 ++
+ 3 files changed, 5 insertions(+)
+
+diff --git a/src/libsystemd/sd-bus/bus-protocol.h b/src/libsystemd/sd-bus/bus-protocol.h
+index 5046d17..4f46468 100644
+--- a/src/libsystemd/sd-bus/bus-protocol.h
++++ b/src/libsystemd/sd-bus/bus-protocol.h
+@@ -21,6 +21,7 @@
+ along with systemd; If not, see <http://www.gnu.org/licenses/>.
+ ***/
+
++#include <endian.h>
+
+ /* Endianness */
+
+diff --git a/src/shared/architecture.h b/src/shared/architecture.h
+index 58e97e5..38780d1 100644
+--- a/src/shared/architecture.h
++++ b/src/shared/architecture.h
+@@ -21,6 +21,8 @@
+ along with systemd; If not, see <http://www.gnu.org/licenses/>.
+ ***/
+
++#include <endian.h>
++
+ #include "util.h"
+
+ /* A cleaned up architecture definition. We don't want to get lost in
+diff --git a/src/shared/gpt.h b/src/shared/gpt.h
+index 278940b..ef3444f 100644
+--- a/src/shared/gpt.h
++++ b/src/shared/gpt.h
+@@ -19,6 +19,8 @@
+ along with systemd; If not, see <http://www.gnu.org/licenses/>.
+ ***/
+
++#include <endian.h>
++
+ #include "sd-id128.h"
+
+ /* We only support root disk discovery for x86, x86-64 and ARM for
+--
+1.8.5.5
+
diff --git a/sys-apps/systemd/files/215-0003-udev-exclude-MD-from-block-device-ownership-event-lo.patch b/sys-apps/systemd/files/215-0003-udev-exclude-MD-from-block-device-ownership-event-lo.patch
new file mode 100644
index 00000000..c730242c
--- /dev/null
+++ b/sys-apps/systemd/files/215-0003-udev-exclude-MD-from-block-device-ownership-event-lo.patch
@@ -0,0 +1,54 @@
+From 9d17a215fb30cb3e49db516a39c9bec2159004a7 Mon Sep 17 00:00:00 2001
+From: Kay Sievers <kay@vrfy.org>
+Date: Thu, 24 Jul 2014 23:37:35 +0200
+Subject: [PATCH 3/3] udev: exclude MD from block device ownership event
+ locking
+
+MD instantiates devices at open(). This is incomptible with the
+locking logic, as the "change" event emitted when stopping a
+device will bring it back.
+---
+ src/udev/udevd.c | 23 +++++++----------------
+ 1 file changed, 7 insertions(+), 16 deletions(-)
+
+diff --git a/src/udev/udevd.c b/src/udev/udevd.c
+index a45d324..db935d6 100644
+--- a/src/udev/udevd.c
++++ b/src/udev/udevd.c
+@@ -285,26 +285,17 @@ static void worker_new(struct event *event)
+ udev_event->exec_delay = exec_delay;
+
+ /*
+- * Take a "read lock" on the device node; this establishes
++ * Take a shared lock on the device node; this establishes
+ * a concept of device "ownership" to serialize device
+- * access. External processes holding a "write lock" will
++ * access. External processes holding an exclusive lock will
+ * cause udev to skip the event handling; in the case udev
+- * acquired the lock, the external process will block until
++ * acquired the lock, the external process can block until
+ * udev has finished its event handling.
+ */
+-
+- /*
+- * <kabi_> since we make check - device seems unused - we try
+- * ioctl to deactivate - and device is found to be opened
+- * <kay> sure, you try to take a write lock
+- * <kay> if you get it udev is out
+- * <kay> if you can't get it, udev is busy
+- * <kabi_> we cannot deactivate openned device (as it is in-use)
+- * <kay> maybe we should just exclude dm from that thing entirely
+- * <kabi_> IMHO this sounds like a good plan for this moment
+- */
+- if (streq_ptr("block", udev_device_get_subsystem(dev)) &&
+- !startswith(udev_device_get_sysname(dev), "dm-")) {
++ if (!streq_ptr(udev_device_get_action(dev), "remove") &&
++ streq_ptr("block", udev_device_get_subsystem(dev)) &&
++ !startswith(udev_device_get_sysname(dev), "dm-") &&
++ !startswith(udev_device_get_sysname(dev), "md")) {
+ struct udev_device *d = dev;
+
+ if (streq_ptr("partition", udev_device_get_devtype(d)))
+--
+1.8.5.5
+
diff --git a/sys-apps/systemd/files/216-lz4-build.patch b/sys-apps/systemd/files/216-lz4-build.patch
new file mode 100644
index 00000000..65fe45cb
--- /dev/null
+++ b/sys-apps/systemd/files/216-lz4-build.patch
@@ -0,0 +1,19 @@
+commit 10893a5cfa7d792ba171282c2ec46b85ed6aae0c
+Author: Gustavo Sverzut Barbieri <gustavo.barbieri@intel.com>
+Date: Thu Sep 25 18:08:02 2014 -0300
+
+ journal: build fix when LZ4 is enabled but XZ is not
+
+diff --git a/src/journal/journal-file.h b/src/journal/journal-file.h
+index da2ef3b..6b4bf0d 100644
+--- a/src/journal/journal-file.h
++++ b/src/journal/journal-file.h
+@@ -78,7 +78,7 @@ typedef struct JournalFile {
+
+ Hashmap *chain_cache;
+
+-#ifdef HAVE_XZ
++#if defined(HAVE_XZ) || defined(HAVE_LZ4)
+ void *compress_buffer;
+ size_t compress_buffer_size;
+ #endif
diff --git a/sys-apps/systemd/files/216-tmpfiles-setup-dev.patch b/sys-apps/systemd/files/216-tmpfiles-setup-dev.patch
new file mode 100644
index 00000000..1fa4a3e7
--- /dev/null
+++ b/sys-apps/systemd/files/216-tmpfiles-setup-dev.patch
@@ -0,0 +1,21 @@
+From 8c94052ee543c3598a3c7b0c46688150aa2c6168 Mon Sep 17 00:00:00 2001
+From: Tom Gundersen <teg@jklm.no>
+Date: Mon, 27 Oct 2014 17:15:42 +0100
+Subject: units: tmpfiles-setup-dev - allow unsafe file creation to happen in
+ /dev at boot
+
+This will allow us to mark static device nodes with '!' to indicate that they should only be created at early boot.
+
+diff --git a/units/systemd-tmpfiles-setup-dev.service.in b/units/systemd-tmpfiles-setup-dev.service.in
+index f3833fd..0123a03 100644
+--- a/units/systemd-tmpfiles-setup-dev.service.in
++++ b/units/systemd-tmpfiles-setup-dev.service.in
+@@ -17,4 +17,4 @@ ConditionCapability=CAP_SYS_MODULE
+ [Service]
+ Type=oneshot
+ RemainAfterExit=yes
+-ExecStart=@rootbindir@/systemd-tmpfiles --prefix=/dev --create
++ExecStart=@rootbindir@/systemd-tmpfiles --prefix=/dev --create --boot
+--
+cgit v0.10.2
+
diff --git a/sys-apps/systemd/files/blacklist-146 b/sys-apps/systemd/files/blacklist-146
new file mode 100644
index 00000000..3e063a35
--- /dev/null
+++ b/sys-apps/systemd/files/blacklist-146
@@ -0,0 +1,48 @@
+# This file lists modules which will not be loaded by udev,
+# not at coldplugging and not on hotplug events.
+
+# Add your own entries to this file
+# in the format "blacklist <name of module>"
+
+# Some examples:
+# evbug is a debug tool and should be loaded explicitly
+blacklist evbug
+
+# Autoloading eth1394 most of the time re-orders your network
+# interfaces, and with buggy kernel 2.6.21, udev persistent-net
+# is not able to rename these devices, so you get eth?_rename devices
+# plus an exceeded 30sec boot timeout
+blacklist eth1394
+
+# You probably want this to not get the console beep loud on every tab :)
+#blacklist pcspkr
+
+# these drivers are very simple, the HID drivers are usually preferred
+#blacklist usbmouse
+#blacklist usbkbd
+
+# Sometimes loading a framebuffer driver at boot gets the console black
+#install pci:v*d*sv*sd*bc03sc*i* /bin/true
+
+# hplip and cups 1.4+ use raw USB devices, so it requires usblp not be loaded
+blacklist usblp
+
+## make broadcom-sta happy
+## <2012-12-08.
+#blacklist ssb
+#blacklist bcma
+#blacklist brcmsmac
+#blacklist b43
+
+# make b43 happy (ditch broadcom-sta)
+# 2012-12-08. Testing needed.
+blacklist wl
+
+# keep nvidia-drivers working, sorry nouveau
+blacklist nouveau
+
+# Known to cause kernel OOPS at boot
+blacklist ite_cir
+
+# Prevents kernel message: Driver 'pcspkr' is already registered, aborting...
+blacklist snd-pcsp
diff --git a/sys-apps/systemd/metadata.xml b/sys-apps/systemd/metadata.xml
new file mode 100644
index 00000000..04f7dcb3
--- /dev/null
+++ b/sys-apps/systemd/metadata.xml
@@ -0,0 +1,20 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <maintainer>
+ <email>systemd@gentoo.org</email>
+ <name>Gentoo systemd team</name>
+ </maintainer>
+ <use>
+ <!-- XXX: describe those two better -->
+ <flag name='audit'>Enable support for <pkg>sys-process/audit</pkg></flag>
+ <flag name='cryptsetup'>Use libcryptsetup</flag>
+ <flag name='efi'>Enable EFI support (installs bootctl)</flag>
+ <flag name='gcrypt'>Enable sealing of journal files using gcrypt</flag>
+ <flag name="gudev">enable libudev gobject interface</flag>
+ <flag name='http'>Enable embedded HTTP server in journald</flag>
+ <flag name='kmod'>Enable kernel module loading via <pkg>sys-apps/kmod</pkg></flag>
+ <flag name='qrcode'>Enable qrcode output support in journal</flag>
+ <flag name='vanilla'>Disable Gentoo-specific behavior and compatibility quirks</flag>
+ </use>
+</pkgmetadata>
diff --git a/sys-apps/systemd/systemd-208-r3.ebuild b/sys-apps/systemd/systemd-208-r3.ebuild
new file mode 100644
index 00000000..6a9efc61
--- /dev/null
+++ b/sys-apps/systemd/systemd-208-r3.ebuild
@@ -0,0 +1,394 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI=5
+
+AUTOTOOLS_PRUNE_LIBTOOL_FILES=all
+PYTHON_COMPAT=( python{2_7,3_2,3_3} )
+inherit autotools-utils bash-completion-r1 fcaps linux-info multilib \
+ multilib-minimal pam python-single-r1 systemd toolchain-funcs udev \
+ user
+
+DESCRIPTION="System and service manager for Linux"
+HOMEPAGE="http://www.freedesktop.org/wiki/Software/systemd"
+SRC_URI="http://www.freedesktop.org/software/systemd/${P}.tar.xz -> ${P}-r1.tar.xz
+ http://dev.gentoo.org/~mgorny/dist/${PN}-gentoo-patchset-${PV}_p19.tar.bz2"
+
+LICENSE="GPL-2 LGPL-2.1 MIT public-domain"
+SLOT="0/1"
+KEYWORDS="~alpha ~amd64 ~arm ~ia64 ~ppc ~ppc64 ~sparc ~x86"
+IUSE="acl audit cryptsetup doc +firmware-loader gcrypt gudev http introspection
+ +kmod lzma pam policykit python qrcode selinux tcpd test
+ vanilla xattr"
+
+MINKV="3.0"
+
+COMMON_DEPEND=">=sys-apps/dbus-1.6.8-r1
+ >=sys-apps/util-linux-2.20
+ sys-libs/libcap
+ acl? ( sys-apps/acl )
+ audit? ( >=sys-process/audit-2 )
+ cryptsetup? ( >=sys-fs/cryptsetup-1.6 )
+ gcrypt? ( >=dev-libs/libgcrypt-1.4.5:0 )
+ gudev? ( >=dev-libs/glib-2[${MULTILIB_USEDEP}] )
+ http? ( net-libs/libmicrohttpd )
+ introspection? ( >=dev-libs/gobject-introspection-1.31.1 )
+ kmod? ( >=sys-apps/kmod-14-r1 )
+ lzma? ( app-arch/xz-utils[${MULTILIB_USEDEP}] )
+ pam? ( virtual/pam )
+ python? ( ${PYTHON_DEPS} )
+ qrcode? ( media-gfx/qrencode )
+ selinux? ( sys-libs/libselinux )
+ tcpd? ( sys-apps/tcp-wrappers )
+ xattr? ( sys-apps/attr )
+ abi_x86_32? ( !<=app-emulation/emul-linux-x86-baselibs-20130224-r9
+ !app-emulation/emul-linux-x86-baselibs[-abi_x86_32(-)] )"
+
+# baselayout-2.2 has /run
+RDEPEND="${COMMON_DEPEND}
+ !app-admin/eselect-init
+ >=sys-apps/baselayout-2.2
+ || (
+ >=sys-apps/util-linux-2.22
+ <sys-apps/sysvinit-2.88-r4
+ )
+ !sys-auth/nss-myhostname
+ !<sys-libs/glibc-2.10
+ !sys-fs/udev"
+
+PDEPEND=">=sys-apps/hwids-20130717-r1[udev]
+ >=sys-fs/udev-init-scripts-25
+ policykit? ( sys-auth/polkit )
+ !vanilla? ( sys-apps/gentoo-systemd-integration )"
+
+# Newer linux-headers needed by ia64, bug #480218
+DEPEND="${COMMON_DEPEND}
+ app-arch/xz-utils
+ app-text/docbook-xml-dtd:4.2
+ app-text/docbook-xsl-stylesheets
+ dev-libs/libxslt
+ dev-util/gperf
+ >=dev-util/intltool-0.50
+ >=sys-devel/binutils-2.23.1
+ >=sys-devel/gcc-4.6
+ >=sys-kernel/linux-headers-${MINKV}
+ ia64? ( >=sys-kernel/linux-headers-3.9 )
+ virtual/pkgconfig
+ doc? ( >=dev-util/gtk-doc-1.18 )"
+
+pkg_pretend() {
+ local CONFIG_CHECK="~AUTOFS4_FS ~BLK_DEV_BSG ~CGROUPS ~DEVTMPFS ~DMIID
+ ~EPOLL ~FANOTIFY ~FHANDLE ~INOTIFY_USER ~IPV6 ~NET ~PROC_FS
+ ~SECCOMP ~SIGNALFD ~SYSFS ~TIMERFD
+ ~!IDE ~!SYSFS_DEPRECATED ~!SYSFS_DEPRECATED_V2
+ ~!GRKERNSEC_PROC"
+
+ use acl && CONFIG_CHECK+=" ~TMPFS_POSIX_ACL"
+ use pam && CONFIG_CHECK+=" ~AUDITSYSCALL"
+ use xattr && CONFIG_CHECK+=" ~TMPFS_XATTR"
+ kernel_is -lt 3 7 && CONFIG_CHECK+=" ~HOTPLUG"
+ use firmware-loader || CONFIG_CHECK+=" ~!FW_LOADER_USER_HELPER"
+
+ if linux_config_exists; then
+ local uevent_helper_path=$(linux_chkconfig_string UEVENT_HELPER_PATH)
+ if [ -n "${uevent_helper_path}" ] && [ "${uevent_helper_path}" != '""' ]; then
+ ewarn "It's recommended to set an empty value to the following kernel config option:"
+ ewarn "CONFIG_UEVENT_HELPER_PATH=${uevent_helper_path}"
+ fi
+ fi
+
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ $(gcc-major-version) -lt 4
+ || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 6 ) ]]
+ then
+ eerror "systemd requires at least gcc 4.6 to build. Please switch the active"
+ eerror "gcc version using gcc-config."
+ die "systemd requires at least gcc 4.6"
+ fi
+ fi
+
+ if [[ ${MERGE_TYPE} != buildonly ]]; then
+ if kernel_is -lt ${MINKV//./ }; then
+ ewarn "Kernel version at least ${MINKV} required"
+ fi
+
+ if ! use firmware-loader && kernel_is -lt 3 8; then
+ ewarn "You seem to be using kernel older than 3.8. Those kernel versions"
+ ewarn "require systemd with USE=firmware-loader to support loading"
+ ewarn "firmware. Missing this flag may cause some hardware not to work."
+ fi
+
+ check_extra_config
+ fi
+}
+
+pkg_setup() {
+ use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+ local PATCHES=(
+ "${WORKDIR}"/${PN}-gentoo-patchset*/*.patch
+ )
+
+ # Bug 463376
+ sed -i -e 's/GROUP="dialout"/GROUP="uucp"/' rules/*.rules || die
+
+ autotools-utils_src_prepare
+}
+
+multilib_src_configure() {
+ local myeconfargs=(
+ --localstatedir=/var
+ --with-pamlibdir=$(getpam_mod_dir)
+ # avoid bash-completion dep
+ --with-bashcompletiondir="$(get_bashcompdir)"
+ # make sure we get /bin:/sbin in $PATH
+ --enable-split-usr
+ # disable sysv compatibility
+ --with-sysvinit-path=
+ --with-sysvrcnd-path=
+ # no deps
+ --enable-efi
+ --enable-ima
+ # optional components/dependencies
+ $(use_enable acl)
+ $(use_enable audit)
+ $(use_enable cryptsetup libcryptsetup)
+ $(use_enable doc gtk-doc)
+ $(use_enable gcrypt)
+ $(use_enable gudev)
+ $(use_enable http microhttpd)
+ $(use_enable introspection)
+ $(use_enable kmod)
+ $(use_enable lzma xz)
+ $(use_enable pam)
+ $(use_enable policykit polkit)
+ $(use_enable python python-devel)
+ $(use python && echo PYTHON_CONFIG=/usr/bin/python-config-${EPYTHON#python})
+ $(use_enable qrcode qrencode)
+ $(use_enable selinux)
+ $(use_enable tcpd tcpwrap)
+ $(use_enable test tests)
+ $(use_enable xattr)
+
+ # not supported (avoid automagic deps in the future)
+ --disable-chkconfig
+
+ # hardcode a few paths to spare some deps
+ QUOTAON=/usr/sbin/quotaon
+ QUOTACHECK=/usr/sbin/quotacheck
+ )
+
+ # Keep using the one where the rules were installed.
+ MY_UDEVDIR=$(get_udevdir)
+
+ if use firmware-loader; then
+ myeconfargs+=(
+ --with-firmware-path="/lib/firmware/updates:/lib/firmware"
+ )
+ fi
+
+ if ! multilib_is_native_abi; then
+ myeconfargs+=(
+ ac_cv_search_cap_init=
+ ac_cv_header_sys_capability_h=yes
+ DBUS_CFLAGS=' '
+ DBUS_LIBS=' '
+
+ --disable-acl
+ --disable-audit
+ --disable-gcrypt
+ --disable-gtk-doc
+ --disable-introspection
+ --disable-kmod
+ --disable-libcryptsetup
+ --disable-microhttpd
+ --disable-pam
+ --disable-polkit
+ --disable-qrencode
+ --disable-selinux
+ --disable-tcpwrap
+ --disable-tests
+ --disable-xattr
+ --disable-xz
+ --disable-python-devel
+ )
+ fi
+
+ # Work around bug 463846.
+ tc-export CC
+
+ autotools-utils_src_configure
+}
+
+multilib_src_compile() {
+ local mymakeopts=(
+ udevlibexecdir="${MY_UDEVDIR}"
+ )
+
+ if multilib_is_native_abi; then
+ emake "${mymakeopts[@]}"
+ else
+ # prerequisites for gudev
+ use gudev && emake src/gudev/gudev{enumtypes,marshal}.{c,h}
+
+ echo 'gentoo: $(lib_LTLIBRARIES) $(pkgconfiglib_DATA)' | \
+ emake "${mymakeopts[@]}" -f Makefile -f - gentoo
+ fi
+}
+
+multilib_src_test() {
+ multilib_is_native_abi || continue
+
+ default
+}
+
+multilib_src_install() {
+ local mymakeopts=(
+ # automake fails with parallel libtool relinking
+ # https://bugs.gentoo.org/show_bug.cgi?id=491398
+ -j1
+
+ udevlibexecdir="${MY_UDEVDIR}"
+ dist_udevhwdb_DATA=
+ DESTDIR="${D}"
+ )
+
+ if multilib_is_native_abi; then
+ emake "${mymakeopts[@]}" install
+ else
+ mymakeopts+=(
+ install-libLTLIBRARIES
+ install-pkgconfiglibDATA
+ install-includeHEADERS
+ # safe to call unconditionally, 'installs' empty list
+ install-libgudev_includeHEADERS
+ install-pkgincludeHEADERS
+ )
+
+ emake "${mymakeopts[@]}"
+ fi
+}
+
+multilib_src_install_all() {
+ prune_libtool_files --modules
+ einstalldocs
+
+ # we just keep sysvinit tools, so no need for the mans
+ rm "${D}"/usr/share/man/man8/{halt,poweroff,reboot,runlevel,shutdown,telinit}.8 \
+ || die
+ rm "${D}"/usr/share/man/man1/init.1 || die
+
+ # Disable storing coredumps in journald, bug #433457
+ mv "${D}"/usr/lib/sysctl.d/50-coredump.conf{,.disabled} || die
+
+ # Preserve empty dirs in /etc & /var, bug #437008
+ keepdir /etc/binfmt.d /etc/modules-load.d /etc/tmpfiles.d \
+ /etc/systemd/ntp-units.d /etc/systemd/user /var/lib/systemd
+
+ # Symlink /etc/sysctl.conf for easy migration.
+ dosym ../sysctl.conf /etc/sysctl.d/99-sysctl.conf
+
+ # Offer a default blacklist that should cover the most
+ # common use cases.
+ insinto /etc/modprobe.d
+ newins "${FILESDIR}"/blacklist-146 blacklist.conf
+}
+
+migrate_locale() {
+ local envd_locale_def="${EROOT%/}/etc/env.d/02locale"
+ local envd_locale=( "${EROOT%/}"/etc/env.d/??locale )
+ local locale_conf="${EROOT%/}/etc/locale.conf"
+
+ if [[ ! -L ${locale_conf} && ! -e ${locale_conf} ]]; then
+ # if locale.conf does not exist...
+ if [[ -e ${envd_locale} ]]; then
+ # ...either copy env.d/??locale if there's one
+ ebegin "Moving ${envd_locale} to ${locale_conf}"
+ mv "${envd_locale}" "${locale_conf}"
+ eend ${?} || FAIL=1
+ else
+ # ...or create a dummy default
+ ebegin "Creating ${locale_conf}"
+ cat > "${locale_conf}" <<-EOF
+ # This file has been created by the sys-apps/systemd ebuild.
+ # See locale.conf(5) and localectl(1).
+
+ # LANG=${LANG}
+ EOF
+ eend ${?} || FAIL=1
+ fi
+ fi
+
+ if [[ ! -L ${envd_locale} ]]; then
+ # now, if env.d/??locale is not a symlink (to locale.conf)...
+ if [[ -e ${envd_locale} ]]; then
+ # ...warn the user that he has duplicate locale settings
+ ewarn
+ ewarn "To ensure consistent behavior, you should replace ${envd_locale}"
+ ewarn "with a symlink to ${locale_conf}. Please migrate your settings"
+ ewarn "and create the symlink with the following command:"
+ ewarn "ln -s -n -f ../locale.conf ${envd_locale}"
+ ewarn
+ else
+ # ...or just create the symlink if there's nothing here
+ ebegin "Creating ${envd_locale_def} -> ../locale.conf symlink"
+ ln -n -s ../locale.conf "${envd_locale_def}"
+ eend ${?} || FAIL=1
+ fi
+ fi
+}
+
+pkg_postinst() {
+ enewgroup systemd-journal
+ if use http; then
+ enewgroup systemd-journal-gateway
+ enewuser systemd-journal-gateway -1 -1 -1 systemd-journal-gateway
+ fi
+ systemd_update_catalog
+
+ # Keep this here in case the database format changes so it gets updated
+ # when required. Despite that this file is owned by sys-apps/hwids.
+ if has_version "sys-apps/hwids[udev]"; then
+ udevadm hwdb --update --root="${ROOT%/}"
+ fi
+
+ udev_reload || FAIL=1
+
+ # Bug 468876
+ fcaps cap_dac_override,cap_sys_ptrace=ep usr/bin/systemd-detect-virt
+
+ # Bug 465468, make sure locales are respect, and ensure consistency
+ # between OpenRC & systemd
+ migrate_locale
+
+ if [[ ${FAIL} ]]; then
+ eerror "One of the postinst commands failed. Please check the postinst output"
+ eerror "for errors. You may need to clean up your system and/or try installing"
+ eerror "systemd again."
+ eerror
+ fi
+
+ if [[ ! -L "${ROOT}"/etc/mtab ]]; then
+ ewarn "Upstream mandates the /etc/mtab file should be a symlink to /proc/mounts."
+ ewarn "Not having it is not supported by upstream and will cause tools like 'df'"
+ ewarn "and 'mount' to not work properly. Please run:"
+ ewarn " # ln -sf '${ROOT}proc/self/mounts' '${ROOT}etc/mtab'"
+ ewarn
+ fi
+
+ if ! has_version sys-apps/systemd-ui; then
+ elog "To get additional features, a number of optional runtime dependencies may"
+ elog "be installed:"
+ elog "- sys-apps/systemd-ui: for GTK+ systemadm UI and gnome-ask-password-agent"
+ fi
+}
+
+pkg_prerm() {
+ # If removing systemd completely, remove the catalog database.
+ if [[ ! ${REPLACED_BY_VERSION} ]]; then
+ rm -f -v "${EROOT}"/var/lib/systemd/catalog/database
+ fi
+}
diff --git a/sys-apps/systemd/systemd-215-r3.ebuild b/sys-apps/systemd/systemd-215-r3.ebuild
new file mode 100644
index 00000000..a1f1efe6
--- /dev/null
+++ b/sys-apps/systemd/systemd-215-r3.ebuild
@@ -0,0 +1,521 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI=5
+
+AUTOTOOLS_PRUNE_LIBTOOL_FILES=all
+PYTHON_COMPAT=( python{2_7,3_2,3_3,3_4} )
+inherit autotools-utils bash-completion-r1 linux-info multilib \
+ multilib-minimal pam python-single-r1 systemd toolchain-funcs udev \
+ user
+
+DESCRIPTION="System and service manager for Linux"
+HOMEPAGE="http://www.freedesktop.org/wiki/Software/systemd"
+SRC_URI="http://www.freedesktop.org/software/systemd/${P}.tar.xz"
+
+LICENSE="GPL-2 LGPL-2.1 MIT public-domain"
+SLOT="0/2"
+KEYWORDS="alpha amd64 arm ~ia64 ppc ~ppc64 ~sparc x86"
+IUSE="acl audit cryptsetup doc elfutils +firmware-loader gcrypt gudev http
+ introspection kdbus +kmod lzma pam policykit python qrcode +seccomp selinux
+ ssl test vanilla"
+
+MINKV="3.8"
+
+COMMON_DEPEND=">=sys-apps/util-linux-2.20:0=
+ sys-libs/libcap:0=
+ acl? ( sys-apps/acl:0= )
+ audit? ( >=sys-process/audit-2:0= )
+ cryptsetup? ( >=sys-fs/cryptsetup-1.6:0= )
+ elfutils? ( >=dev-libs/elfutils-0.158:0= )
+ gcrypt? ( >=dev-libs/libgcrypt-1.4.5:0=[${MULTILIB_USEDEP}] )
+ gudev? ( >=dev-libs/glib-2.34.3:2=[${MULTILIB_USEDEP}] )
+ http? (
+ >=net-libs/libmicrohttpd-0.9.33:0=
+ ssl? ( >=net-libs/gnutls-3.1.4:0= )
+ )
+ introspection? ( >=dev-libs/gobject-introspection-1.31.1:0= )
+ kmod? ( >=sys-apps/kmod-15:0= )
+ lzma? ( >=app-arch/xz-utils-5.0.5-r1:0=[${MULTILIB_USEDEP}] )
+ pam? ( virtual/pam:= )
+ python? ( ${PYTHON_DEPS} )
+ qrcode? ( media-gfx/qrencode:0= )
+ seccomp? ( sys-libs/libseccomp:0= )
+ selinux? ( sys-libs/libselinux:0= )
+ abi_x86_32? ( !<=app-emulation/emul-linux-x86-baselibs-20130224-r9
+ !app-emulation/emul-linux-x86-baselibs[-abi_x86_32(-)] )"
+
+# baselayout-2.2 has /run
+RDEPEND="${COMMON_DEPEND}
+ !app-admin/eselect-init
+ >=sys-apps/baselayout-2.2
+ || (
+ >=sys-apps/util-linux-2.22
+ <sys-apps/sysvinit-2.88-r4
+ )
+ !sys-auth/nss-myhostname
+ !<sys-libs/glibc-2.14
+ !sys-fs/udev"
+
+# sys-apps/dbus: the daemon only (+ build-time lib dep for tests)
+PDEPEND=">=sys-apps/dbus-1.6.8-r1:0[systemd]
+ >=sys-apps/hwids-20130717-r1[udev]
+ >=sys-fs/udev-init-scripts-25
+ policykit? ( sys-auth/polkit )
+ !vanilla? ( sys-apps/gentoo-systemd-integration )"
+
+# Newer linux-headers needed by ia64, bug #480218
+DEPEND="${COMMON_DEPEND}
+ app-arch/xz-utils:0
+ dev-util/gperf
+ >=dev-util/intltool-0.50
+ >=sys-apps/coreutils-8.16
+ >=sys-devel/binutils-2.23.1
+ >=sys-devel/gcc-4.6
+ >=sys-kernel/linux-headers-${MINKV}
+ ia64? ( >=sys-kernel/linux-headers-3.9 )
+ virtual/pkgconfig
+ doc? ( >=dev-util/gtk-doc-1.18 )
+ python? ( dev-python/lxml[${PYTHON_USEDEP}] )
+ test? ( >=sys-apps/dbus-1.6.8-r1:0 )"
+
+src_prepare() {
+ local PATCHES=(
+ "${FILESDIR}/${PV}-0001-always-check-for-__BYTE_ORDER-__BIG_ENDIAN-when-chec.patch"
+ "${FILESDIR}/${PV}-0002-endian-explicitly-include-endian.h-wherever-we-want-.patch"
+ "${FILESDIR}/${PV}-0003-udev-exclude-MD-from-block-device-ownership-event-lo.patch"
+ )
+
+ # Bug 463376
+ sed -i -e 's/GROUP="dialout"/GROUP="uucp"/' rules/*.rules || die
+
+ # http://thread.gmane.org/gmane.comp.sysutils.systemd.devel/20815
+ touch src/core/org.freedesktop.systemd1.policy.in.in || die
+
+ # http://thread.gmane.org/gmane.comp.sysutils.systemd.devel/21074
+ touch units/emergency.service.in || die
+
+ autotools-utils_src_prepare
+}
+
+pkg_pretend() {
+ local CONFIG_CHECK="~AUTOFS4_FS ~BLK_DEV_BSG ~CGROUPS ~DEVTMPFS ~DMIID
+ ~EPOLL ~FANOTIFY ~FHANDLE ~INOTIFY_USER ~IPV6 ~NET ~NET_NS ~PROC_FS
+ ~SECCOMP ~SIGNALFD ~SYSFS ~TIMERFD ~TMPFS_XATTR
+ ~!IDE ~!SYSFS_DEPRECATED ~!SYSFS_DEPRECATED_V2
+ ~!GRKERNSEC_PROC"
+
+ use acl && CONFIG_CHECK+=" ~TMPFS_POSIX_ACL"
+ kernel_is -lt 3 7 && CONFIG_CHECK+=" ~HOTPLUG"
+ use firmware-loader || CONFIG_CHECK+=" ~!FW_LOADER_USER_HELPER"
+
+ if linux_config_exists; then
+ local uevent_helper_path=$(linux_chkconfig_string UEVENT_HELPER_PATH)
+ if [ -n "${uevent_helper_path}" ] && [ "${uevent_helper_path}" != '""' ]; then
+ ewarn "It's recommended to set an empty value to the following kernel config option:"
+ ewarn "CONFIG_UEVENT_HELPER_PATH=${uevent_helper_path}"
+ fi
+ fi
+
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ $(gcc-major-version) -lt 4
+ || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 6 ) ]]
+ then
+ eerror "systemd requires at least gcc 4.6 to build. Please switch the active"
+ eerror "gcc version using gcc-config."
+ die "systemd requires at least gcc 4.6"
+ fi
+ fi
+
+ if [[ ${MERGE_TYPE} != buildonly ]]; then
+ if kernel_is -lt ${MINKV//./ }; then
+ ewarn "Kernel version at least ${MINKV} required"
+ fi
+
+ if ! use firmware-loader && kernel_is -lt 3 8; then
+ ewarn "You seem to be using kernel older than 3.8. Those kernel versions"
+ ewarn "require systemd with USE=firmware-loader to support loading"
+ ewarn "firmware. Missing this flag may cause some hardware not to work."
+ fi
+
+ check_extra_config
+ fi
+}
+
+pkg_setup() {
+ use python && python-single-r1_pkg_setup
+}
+
+src_configure() {
+ # Keep using the one where the rules were installed.
+ MY_UDEVDIR=$(get_udevdir)
+ # Fix systems broken by bug #509454.
+ [[ ${MY_UDEVDIR} ]] || MY_UDEVDIR=/lib/udev
+
+ multilib-minimal_src_configure
+}
+
+multilib_native_enable() {
+ if multilib_is_native_abi; then
+ echo "--enable-${1}"
+ else
+ echo "--disable-${1}"
+ fi
+}
+
+multilib_src_configure() {
+ local myeconfargs=(
+ # disable -flto since it is an optimization flag
+ # and makes distcc less effective
+ cc_cv_CFLAGS__flto=no
+
+ # Workaround for bug 516346
+ --enable-dependency-tracking
+
+ --disable-maintainer-mode
+ --localstatedir=/var
+ --with-pamlibdir=$(getpam_mod_dir)
+ # avoid bash-completion dep
+ --with-bashcompletiondir="$(get_bashcompdir)"
+ # make sure we get /bin:/sbin in $PATH
+ --enable-split-usr
+ # disable sysv compatibility
+ --with-sysvinit-path=
+ --with-sysvrcnd-path=
+ # no deps
+ --enable-efi
+ --enable-ima
+
+ # Optional components/dependencies
+ $(multilib_native_use_enable acl)
+ $(multilib_native_use_enable audit)
+ $(multilib_native_use_enable cryptsetup libcryptsetup)
+ $(multilib_native_use_enable doc gtk-doc)
+ $(multilib_native_use_enable elfutils)
+ $(use_enable gcrypt)
+ $(use_enable gudev)
+ $(multilib_native_use_enable http microhttpd)
+ $(usex http $(multilib_native_use_enable ssl gnutls) --disable-gnutls)
+ $(multilib_native_use_enable introspection)
+ $(use_enable kdbus)
+ $(multilib_native_use_enable kmod)
+ $(use_enable lzma xz)
+ $(multilib_native_use_enable pam)
+ $(multilib_native_use_enable policykit polkit)
+ $(multilib_native_use_with python)
+ $(multilib_native_use_enable python python-devel)
+ $(multilib_native_use_enable qrcode qrencode)
+ $(multilib_native_use_enable seccomp)
+ $(multilib_native_use_enable selinux)
+ $(multilib_native_use_enable test tests)
+ $(multilib_native_use_enable test dbus)
+
+ # Disable optional binaries for non-native abis
+ $(multilib_native_enable backlight)
+ $(multilib_native_enable binfmt)
+ $(multilib_native_enable bootchart)
+ $(multilib_native_enable coredump)
+ $(multilib_native_enable hostnamed)
+ $(multilib_native_enable localed)
+ $(multilib_native_enable logind)
+ $(multilib_native_enable machined)
+ $(multilib_native_enable networkd)
+ $(multilib_native_enable quotacheck)
+ $(multilib_native_enable randomseed)
+ $(multilib_native_enable readahead)
+ $(multilib_native_enable resolved)
+ $(multilib_native_enable rfkill)
+ $(multilib_native_enable sysusers)
+ $(multilib_native_enable timedated)
+ $(multilib_native_enable timesyncd)
+ $(multilib_native_enable tmpfiles)
+ $(multilib_native_enable vconsole)
+
+ # not supported (avoid automagic deps in the future)
+ --disable-apparmor
+ --disable-chkconfig
+
+ # hardcode a few paths to spare some deps
+ QUOTAON=/usr/sbin/quotaon
+ QUOTACHECK=/usr/sbin/quotacheck
+
+ # dbus paths
+ --with-dbuspolicydir="${EPREFIX}/etc/dbus-1/system.d"
+ --with-dbussessionservicedir="${EPREFIX}/usr/share/dbus-1/services"
+ --with-dbussystemservicedir="${EPREFIX}/usr/share/dbus-1/system-services"
+ --with-dbusinterfacedir="${EPREFIX}/usr/share/dbus-1/interfaces"
+
+ --with-ntp-servers="0.gentoo.pool.ntp.org 1.gentoo.pool.ntp.org 2.gentoo.pool.ntp.org 3.gentoo.pool.ntp.org"
+ )
+
+ if use firmware-loader; then
+ myeconfargs+=(
+ --with-firmware-path="/lib/firmware/updates:/lib/firmware"
+ )
+ fi
+
+ # Added for testing; this is UNSUPPORTED by the Gentoo systemd team!
+ if [[ -n ${ROOTPREFIX+set} ]]; then
+ myeconfargs+=(
+ --with-rootprefix="${ROOTPREFIX}"
+ --with-rootlibdir="${ROOTPREFIX}/$(get_libdir)"
+ )
+ fi
+
+ if ! multilib_is_native_abi; then
+ myeconfargs+=(
+ ac_cv_search_cap_init=
+ ac_cv_header_sys_capability_h=yes
+ )
+ fi
+
+ # Work around bug 463846.
+ tc-export CC
+
+ autotools-utils_src_configure
+}
+
+multilib_src_compile() {
+ local mymakeopts=(
+ udevlibexecdir="${MY_UDEVDIR}"
+ )
+
+ if multilib_is_native_abi; then
+ emake "${mymakeopts[@]}"
+ else
+ # prerequisites for gudev
+ use gudev && emake src/gudev/gudev{enumtypes,marshal}.{c,h}
+
+ echo 'gentoo: $(BUILT_SOURCES)' | \
+ emake "${mymakeopts[@]}" -f Makefile -f - gentoo
+ echo 'gentoo: $(lib_LTLIBRARIES) $(pkgconfiglib_DATA)' | \
+ emake "${mymakeopts[@]}" -f Makefile -f - gentoo
+ fi
+}
+
+multilib_src_test() {
+ multilib_is_native_abi || continue
+
+ default
+}
+
+multilib_src_install() {
+ local mymakeopts=(
+ # automake fails with parallel libtool relinking
+ # https://bugs.gentoo.org/show_bug.cgi?id=491398
+ -j1
+
+ udevlibexecdir="${MY_UDEVDIR}"
+ dist_udevhwdb_DATA=
+ DESTDIR="${D}"
+ )
+
+ if multilib_is_native_abi; then
+ emake "${mymakeopts[@]}" install
+ else
+ mymakeopts+=(
+ install-libLTLIBRARIES
+ install-pkgconfiglibDATA
+ install-includeHEADERS
+ # safe to call unconditionally, 'installs' empty list
+ install-libgudev_includeHEADERS
+ install-pkgincludeHEADERS
+ )
+
+ emake "${mymakeopts[@]}"
+ fi
+
+ # install compat pkg-config files
+ local pcfiles=( src/compat-libs/libsystemd-{daemon,id128,journal,login}.pc )
+ emake "${mymakeopts[@]}" install-pkgconfiglibDATA \
+ pkgconfiglib_DATA="${pcfiles[*]}"
+
+ # Create symlinks for old libs
+ dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-daemon.so"
+ dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-id128.so"
+ dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-journal.so"
+ dosym libsystemd.so "/usr/$(get_libdir)/libsystemd-login.so"
+
+ # Kogaion: create systemd-run symlink in /bin. lvm2 lvmetad has a
+ # udev rule that expects systemd-run to be in /bin. And lvmetad is
+ # used by Anaconda.
+ dosym "../usr/bin/systemd-run" "/bin/systemd-run"
+}
+
+multilib_src_install_all() {
+ prune_libtool_files --modules
+ einstalldocs
+
+ # we just keep sysvinit tools, so no need for the mans
+ rm "${D}"/usr/share/man/man8/{halt,poweroff,reboot,runlevel,shutdown,telinit}.8 \
+ || die
+ rm "${D}"/usr/share/man/man1/init.1 || die
+
+ # Disable storing coredumps in journald, bug #433457
+ mv "${D}"/usr/lib/sysctl.d/50-coredump.conf{,.disabled} || die
+
+ # Preserve empty dirs in /etc & /var, bug #437008
+ keepdir /etc/binfmt.d /etc/modules-load.d /etc/tmpfiles.d \
+ /etc/systemd/ntp-units.d /etc/systemd/user /var/lib/systemd
+
+ # Symlink /etc/sysctl.conf for easy migration.
+ dosym ../sysctl.conf /etc/sysctl.d/99-sysctl.conf
+
+ # If we install these symlinks, there is no way for the sysadmin to remove them
+ # permanently.
+ rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-networkd.service
+ rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-resolved.service
+ rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-timesyncd.service
+ rm -rf "${D}"/etc/systemd/system/network-online.target.wants
+
+ # Offer a default blacklist that should cover the most
+ # common use cases.
+ insinto /etc/modprobe.d
+ newins "${FILESDIR}"/blacklist-146 blacklist.conf
+}
+
+migrate_locale() {
+ local envd_locale_def="${EROOT%/}/etc/env.d/02locale"
+ local envd_locale=( "${EROOT%/}"/etc/env.d/??locale )
+ local locale_conf="${EROOT%/}/etc/locale.conf"
+
+ if [[ ! -L ${locale_conf} && ! -e ${locale_conf} ]]; then
+ # If locale.conf does not exist...
+ if [[ -e ${envd_locale} ]]; then
+ # ...either copy env.d/??locale if there's one
+ ebegin "Moving ${envd_locale} to ${locale_conf}"
+ mv "${envd_locale}" "${locale_conf}"
+ eend ${?} || FAIL=1
+ else
+ # ...or create a dummy default
+ ebegin "Creating ${locale_conf}"
+ cat > "${locale_conf}" <<-EOF
+ # This file has been created by the sys-apps/systemd ebuild.
+ # See locale.conf(5) and localectl(1).
+
+ # LANG=${LANG}
+ EOF
+ eend ${?} || FAIL=1
+ fi
+ fi
+
+ if [[ ! -L ${envd_locale} ]]; then
+ # now, if env.d/??locale is not a symlink (to locale.conf)...
+ if [[ -e ${envd_locale} ]]; then
+ # ...warn the user that he has duplicate locale settings
+ ewarn
+ ewarn "To ensure consistent behavior, you should replace ${envd_locale}"
+ ewarn "with a symlink to ${locale_conf}. Please migrate your settings"
+ ewarn "and create the symlink with the following command:"
+ ewarn "ln -s -n -f ../locale.conf ${envd_locale}"
+ ewarn
+ else
+ # ...or just create the symlink if there's nothing here
+ ebegin "Creating ${envd_locale_def} -> ../locale.conf symlink"
+ ln -n -s ../locale.conf "${envd_locale_def}"
+ eend ${?} || FAIL=1
+ fi
+ fi
+}
+
+migrate_net_name_slot() {
+ # If user has disabled 80-net-name-slot.rules using a empty file or a symlink to /dev/null,
+ # do the same for 80-net-setup-link.rules to keep the old behavior
+ local net_move=no
+ local net_name_slot_sym=no
+ local net_rules_path="${EROOT%/}"/etc/udev/rules.d
+ local net_name_slot="${net_rules_path}"/80-net-name-slot.rules
+ local net_setup_link="${net_rules_path}"/80-net-setup-link.rules
+ if [[ -e ${net_setup_link} ]]; then
+ net_move=no
+ elif [[ -f ${net_name_slot} && $(sed -e "/^#/d" -e "/^\W*$/d" ${net_name_slot} | wc -l) == 0 ]]; then
+ net_move=yes
+ elif [[ -L ${net_name_slot} && $(readlink ${net_name_slot}) == /dev/null ]]; then
+ net_move=yes
+ net_name_slot_sym=yes
+ fi
+ if [[ ${net_move} == yes ]]; then
+ ebegin "Copying ${net_name_slot} to ${net_setup_link}"
+
+ if [[ ${net_name_slot_sym} == yes ]]; then
+ ln -nfs /dev/null "${net_setup_link}"
+ else
+ cp "${net_name_slot}" "${net_setup_link}"
+ fi
+ eend $? || FAIL=1
+ fi
+}
+
+pkg_postinst() {
+ newusergroup() {
+ enewgroup "$1"
+ enewuser "$1" -1 -1 -1 "$1"
+ }
+
+ enewgroup input
+ enewgroup systemd-journal
+ newusergroup systemd-bus-proxy
+ newusergroup systemd-network
+ newusergroup systemd-resolve
+ newusergroup systemd-timesync
+ use http && newusergroup systemd-journal-gateway
+
+ systemd_update_catalog
+
+ # Keep this here in case the database format changes so it gets updated
+ # when required. Despite that this file is owned by sys-apps/hwids.
+ if has_version "sys-apps/hwids[udev]"; then
+ udevadm hwdb --update --root="${ROOT%/}"
+ fi
+
+ udev_reload || FAIL=1
+
+ # Bug 465468, make sure locales are respect, and ensure consistency
+ # between OpenRC & systemd
+ migrate_locale
+
+ # Migrate 80-net-name-slot.rules -> 80-net-setup-link.rules
+ migrate_net_name_slot
+
+ if [[ ${FAIL} ]]; then
+ eerror "One of the postinst commands failed. Please check the postinst output"
+ eerror "for errors. You may need to clean up your system and/or try installing"
+ eerror "systemd again."
+ eerror
+ fi
+
+ if [[ ! -L "${ROOT}"/etc/mtab ]]; then
+ ewarn "Upstream mandates the /etc/mtab file should be a symlink to /proc/mounts."
+ ewarn "Not having it is not supported by upstream and will cause tools like 'df'"
+ ewarn "and 'mount' to not work properly. Please run:"
+ ewarn " # ln -sf '${ROOT}proc/self/mounts' '${ROOT}etc/mtab'"
+ ewarn
+ fi
+
+ if [[ $(readlink "${ROOT}"/etc/resolv.conf) == */run/systemd/network/resolv.conf ]]; then
+ ewarn "resolv.conf is now generated by systemd-resolved. To use it, enable"
+ ewarn "systemd-resolved.service, and create a symlink from /etc/resolv.conf"
+ ewarn "to /run/systemd/resolve/resolv.conf"
+ ewarn
+ fi
+
+ if ! has_version sys-apps/systemd-ui; then
+ elog "To get additional features, a number of optional runtime dependencies may"
+ elog "be installed:"
+ elog "- sys-apps/systemd-ui: for GTK+ systemadm UI and gnome-ask-password-agent"
+ fi
+
+ if has_version sys-apps/openrc &&
+ ! has_version sys-fs/udev-init-scripts; then
+ elog "If you plan to boot using OpenRC and udev or eudev, you"
+ elog "need to install the udev-init-scripts package."
+ fi
+}
+
+pkg_prerm() {
+ # If removing systemd completely, remove the catalog database.
+ if [[ ! ${REPLACED_BY_VERSION} ]]; then
+ rm -f -v "${EROOT}"/var/lib/systemd/catalog/database
+ fi
+}
diff --git a/sys-apps/systemd/systemd-216-r3.ebuild b/sys-apps/systemd/systemd-216-r3.ebuild
new file mode 100644
index 00000000..143febdc
--- /dev/null
+++ b/sys-apps/systemd/systemd-216-r3.ebuild
@@ -0,0 +1,526 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/sys-apps/systemd/systemd-216-r3.ebuild,v 1.9 2015/04/27 12:35:00 ago Exp $
+
+EAPI=5
+
+AUTOTOOLS_PRUNE_LIBTOOL_FILES=all
+PYTHON_COMPAT=( python{2_7,3_3,3_4} )
+inherit autotools-utils bash-completion-r1 linux-info multilib \
+ multilib-minimal pam python-single-r1 systemd toolchain-funcs udev \
+ user
+
+DESCRIPTION="System and service manager for Linux"
+HOMEPAGE="http://www.freedesktop.org/wiki/Software/systemd"
+SRC_URI="http://www.freedesktop.org/software/systemd/${P}.tar.xz"
+
+LICENSE="GPL-2 LGPL-2.1 MIT public-domain"
+SLOT="0/2"
+KEYWORDS="alpha amd64 arm ia64 ppc ppc64 sparc x86"
+IUSE="acl apparmor audit cryptsetup curl doc elfutils +firmware-loader gcrypt gudev http
+ idn introspection kdbus +kmod lz4 lzma pam policykit python qrcode +seccomp
+ selinux ssl sysv-utils test vanilla"
+
+MINKV="3.8"
+
+COMMON_DEPEND=">=sys-apps/util-linux-2.20:0=
+ sys-libs/libcap:0=
+ !<sys-libs/glibc-2.16
+ acl? ( sys-apps/acl:0= )
+ apparmor? ( sys-libs/libapparmor:0= )
+ audit? ( >=sys-process/audit-2:0= )
+ cryptsetup? ( >=sys-fs/cryptsetup-1.6:0= )
+ curl? ( net-misc/curl:0= )
+ elfutils? ( >=dev-libs/elfutils-0.158:0= )
+ gcrypt? ( >=dev-libs/libgcrypt-1.4.5:0=[${MULTILIB_USEDEP}] )
+ gudev? ( >=dev-libs/glib-2.34.3:2=[${MULTILIB_USEDEP}] )
+ http? (
+ >=net-libs/libmicrohttpd-0.9.33:0=
+ ssl? ( >=net-libs/gnutls-3.1.4:0= )
+ )
+ idn? ( net-dns/libidn:0= )
+ introspection? ( >=dev-libs/gobject-introspection-1.31.1:0= )
+ kmod? ( >=sys-apps/kmod-15:0= )
+ lz4? ( >=app-arch/lz4-0_p119:0=[${MULTILIB_USEDEP}] )
+ lzma? ( >=app-arch/xz-utils-5.0.5-r1:0=[${MULTILIB_USEDEP}] )
+ pam? ( virtual/pam:= )
+ python? ( ${PYTHON_DEPS} )
+ qrcode? ( media-gfx/qrencode:0= )
+ seccomp? ( sys-libs/libseccomp:0= )
+ selinux? ( sys-libs/libselinux:0= )
+ sysv-utils? (
+ !sys-apps/systemd-sysv-utils
+ !sys-apps/sysvinit
+ >=sys-apps/util-linux-2.24.1-r2 )
+ abi_x86_32? ( !<=app-emulation/emul-linux-x86-baselibs-20130224-r9
+ !app-emulation/emul-linux-x86-baselibs[-abi_x86_32(-)] )"
+
+# baselayout-2.2 has /run
+RDEPEND="${COMMON_DEPEND}
+ !app-admin/eselect-init
+ >=sys-apps/baselayout-2.2
+ || (
+ >=sys-apps/util-linux-2.22
+ <sys-apps/sysvinit-2.88-r4
+ )
+ !sys-auth/nss-myhostname
+ !sys-fs/udev"
+
+# sys-apps/dbus: the daemon only (+ build-time lib dep for tests)
+PDEPEND=">=sys-apps/dbus-1.6.8-r1:0[systemd]
+ >=sys-apps/hwids-20130717-r1[udev]
+ >=sys-fs/udev-init-scripts-25
+ policykit? ( sys-auth/polkit )
+ !vanilla? ( sys-apps/gentoo-systemd-integration )"
+
+# Newer linux-headers needed by ia64, bug #480218
+DEPEND="${COMMON_DEPEND}
+ app-arch/xz-utils:0
+ dev-util/gperf
+ >=dev-util/intltool-0.50
+ >=sys-apps/coreutils-8.16
+ >=sys-devel/binutils-2.23.1
+ >=sys-devel/gcc-4.6
+ >=sys-kernel/linux-headers-${MINKV}
+ ia64? ( >=sys-kernel/linux-headers-3.9 )
+ virtual/pkgconfig
+ doc? ( >=dev-util/gtk-doc-1.18 )
+ python? ( dev-python/lxml[${PYTHON_USEDEP}] )
+ test? ( >=sys-apps/dbus-1.6.8-r1:0 )"
+
+PATCHES=(
+ "${FILESDIR}/216-lz4-build.patch"
+ "${FILESDIR}/216-tmpfiles-setup-dev.patch"
+)
+
+src_prepare() {
+ # Bug 463376
+ sed -i -e 's/GROUP="dialout"/GROUP="uucp"/' rules/*.rules || die
+
+ autotools-utils_src_prepare
+}
+
+pkg_pretend() {
+ local CONFIG_CHECK="~AUTOFS4_FS ~BLK_DEV_BSG ~CGROUPS ~DEVTMPFS ~DMIID
+ ~EPOLL ~FANOTIFY ~FHANDLE ~INOTIFY_USER ~IPV6 ~NET ~NET_NS ~PROC_FS
+ ~SECCOMP ~SIGNALFD ~SYSFS ~TIMERFD ~TMPFS_XATTR
+ ~!IDE ~!SYSFS_DEPRECATED ~!SYSFS_DEPRECATED_V2
+ ~!GRKERNSEC_PROC"
+
+ use acl && CONFIG_CHECK+=" ~TMPFS_POSIX_ACL"
+ kernel_is -lt 3 7 && CONFIG_CHECK+=" ~HOTPLUG"
+ use firmware-loader || CONFIG_CHECK+=" ~!FW_LOADER_USER_HELPER"
+
+ if linux_config_exists; then
+ local uevent_helper_path=$(linux_chkconfig_string UEVENT_HELPER_PATH)
+ if [ -n "${uevent_helper_path}" ] && [ "${uevent_helper_path}" != '""' ]; then
+ ewarn "It's recommended to set an empty value to the following kernel config option:"
+ ewarn "CONFIG_UEVENT_HELPER_PATH=${uevent_helper_path}"
+ fi
+ fi
+
+ if [[ ${MERGE_TYPE} != binary ]]; then
+ if [[ $(gcc-major-version) -lt 4
+ || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 6 ) ]]
+ then
+ eerror "systemd requires at least gcc 4.6 to build. Please switch the active"
+ eerror "gcc version using gcc-config."
+ die "systemd requires at least gcc 4.6"
+ fi
+ fi
+
+ if [[ ${MERGE_TYPE} != buildonly ]]; then
+ if kernel_is -lt ${MINKV//./ }; then
+ ewarn "Kernel version at least ${MINKV} required"
+ fi
+
+ if ! use firmware-loader && kernel_is -lt 3 8; then
+ ewarn "You seem to be using kernel older than 3.8. Those kernel versions"
+ ewarn "require systemd with USE=firmware-loader to support loading"
+ ewarn "firmware. Missing this flag may cause some hardware not to work."
+ fi
+
+ check_extra_config
+ fi
+}
+
+pkg_setup() {
+ use python && python-single-r1_pkg_setup
+}
+
+src_configure() {
+ # Keep using the one where the rules were installed.
+ MY_UDEVDIR=$(get_udevdir)
+ # Fix systems broken by bug #509454.
+ [[ ${MY_UDEVDIR} ]] || MY_UDEVDIR=/lib/udev
+
+ multilib-minimal_src_configure
+}
+
+multilib_native_enable() {
+ if multilib_is_native_abi; then
+ echo "--enable-${1}"
+ else
+ echo "--disable-${1}"
+ fi
+}
+
+multilib_src_configure() {
+ local myeconfargs=(
+ # disable -flto since it is an optimization flag
+ # and makes distcc less effective
+ cc_cv_CFLAGS__flto=no
+
+ # Workaround for bug 516346
+ --enable-dependency-tracking
+
+ --disable-maintainer-mode
+ --localstatedir=/var
+ --with-pamlibdir=$(getpam_mod_dir)
+ # avoid bash-completion dep
+ --with-bashcompletiondir="$(get_bashcompdir)"
+ # make sure we get /bin:/sbin in $PATH
+ --enable-split-usr
+ # For testing.
+ --with-rootprefix="${ROOTPREFIX-/usr}"
+ --with-rootlibdir="${ROOTPREFIX-/usr}/$(get_libdir)"
+ # disable sysv compatibility
+ --with-sysvinit-path=
+ --with-sysvrcnd-path=
+ # no deps
+ --enable-efi
+ --enable-ima
+
+ # Optional components/dependencies
+ $(multilib_native_use_enable acl)
+ $(multilib_native_use_enable apparmor)
+ $(multilib_native_use_enable audit)
+ $(multilib_native_use_enable cryptsetup libcryptsetup)
+ $(multilib_native_use_enable curl libcurl)
+ $(multilib_native_use_enable doc gtk-doc)
+ $(multilib_native_use_enable elfutils)
+ $(use_enable gcrypt)
+ $(use_enable gudev)
+ $(multilib_native_use_enable http microhttpd)
+ $(usex http $(multilib_native_use_enable ssl gnutls) --disable-gnutls)
+ $(multilib_native_use_enable idn libidn)
+ $(multilib_native_use_enable introspection)
+ $(use_enable kdbus)
+ $(multilib_native_use_enable kmod)
+ $(use_enable lz4)
+ $(use_enable lzma xz)
+ $(multilib_native_use_enable pam)
+ $(multilib_native_use_enable policykit polkit)
+ $(multilib_native_use_with python)
+ $(multilib_native_use_enable python python-devel)
+ $(multilib_native_use_enable qrcode qrencode)
+ $(multilib_native_use_enable seccomp)
+ $(multilib_native_use_enable selinux)
+ $(multilib_native_use_enable test tests)
+ $(multilib_native_use_enable test dbus)
+
+ # Disable optional binaries for non-native abis
+ $(multilib_native_enable backlight)
+ $(multilib_native_enable binfmt)
+ $(multilib_native_enable bootchart)
+ $(multilib_native_enable coredump)
+ $(multilib_native_enable firstboot)
+ $(multilib_native_enable hostnamed)
+ $(multilib_native_enable localed)
+ $(multilib_native_enable logind)
+ $(multilib_native_enable machined)
+ $(multilib_native_enable networkd)
+ $(multilib_native_enable quotacheck)
+ $(multilib_native_enable randomseed)
+ $(multilib_native_enable readahead)
+ $(multilib_native_enable resolved)
+ $(multilib_native_enable rfkill)
+ $(multilib_native_enable sysusers)
+ $(multilib_native_enable timedated)
+ $(multilib_native_enable timesyncd)
+ $(multilib_native_enable tmpfiles)
+ $(multilib_native_enable vconsole)
+
+ # not supported (avoid automagic deps in the future)
+ --disable-chkconfig
+
+ # hardcode a few paths to spare some deps
+ QUOTAON=/usr/sbin/quotaon
+ QUOTACHECK=/usr/sbin/quotacheck
+
+ # dbus paths
+ --with-dbuspolicydir="${EPREFIX}/etc/dbus-1/system.d"
+ --with-dbussessionservicedir="${EPREFIX}/usr/share/dbus-1/services"
+ --with-dbussystemservicedir="${EPREFIX}/usr/share/dbus-1/system-services"
+ --with-dbusinterfacedir="${EPREFIX}/usr/share/dbus-1/interfaces"
+
+ --with-ntp-servers="0.gentoo.pool.ntp.org 1.gentoo.pool.ntp.org 2.gentoo.pool.ntp.org 3.gentoo.pool.ntp.org"
+ )
+
+ if use firmware-loader; then
+ myeconfargs+=(
+ --with-firmware-path="/lib/firmware/updates:/lib/firmware"
+ )
+ fi
+
+ if ! multilib_is_native_abi; then
+ myeconfargs+=(
+ ac_cv_search_cap_init=
+ ac_cv_header_sys_capability_h=yes
+ )
+ fi
+
+ # Work around bug 463846.
+ tc-export CC
+
+ autotools-utils_src_configure
+}
+
+multilib_src_compile() {
+ local mymakeopts=(
+ udevlibexecdir="${MY_UDEVDIR}"
+ )
+
+ if multilib_is_native_abi; then
+ emake "${mymakeopts[@]}"
+ else
+ # prerequisites for gudev
+ use gudev && emake src/gudev/gudev{enumtypes,marshal}.{c,h}
+
+ echo 'gentoo: $(BUILT_SOURCES)' | \
+ emake "${mymakeopts[@]}" -f Makefile -f - gentoo
+ echo 'gentoo: $(lib_LTLIBRARIES) $(pkgconfiglib_DATA)' | \
+ emake "${mymakeopts[@]}" -f Makefile -f - gentoo
+ fi
+}
+
+multilib_src_test() {
+ multilib_is_native_abi || continue
+
+ default
+}
+
+multilib_src_install() {
+ local mymakeopts=(
+ # automake fails with parallel libtool relinking
+ # https://bugs.gentoo.org/show_bug.cgi?id=491398
+ -j1
+
+ udevlibexecdir="${MY_UDEVDIR}"
+ dist_udevhwdb_DATA=
+ DESTDIR="${D}"
+ )
+
+ if multilib_is_native_abi; then
+ emake "${mymakeopts[@]}" install
+ else
+ mymakeopts+=(
+ install-libLTLIBRARIES
+ install-pkgconfiglibDATA
+ install-includeHEADERS
+ # safe to call unconditionally, 'installs' empty list
+ install-libgudev_includeHEADERS
+ install-pkgincludeHEADERS
+ )
+
+ emake "${mymakeopts[@]}"
+ fi
+
+ # install compat pkg-config files
+ local pcfiles=( src/compat-libs/libsystemd-{daemon,id128,journal,login}.pc )
+ emake "${mymakeopts[@]}" install-pkgconfiglibDATA \
+ pkgconfiglib_DATA="${pcfiles[*]}"
+
+ # Kogaion: create systemd-run symlink in /bin. lvm2 lvmetad has a
+ # udev rule that expects systemd-run to be in /bin. And lvmetad is
+ # used by Anaconda.
+ dosym "../usr/bin/systemd-run" "/bin/systemd-run"
+}
+
+multilib_src_install_all() {
+ prune_libtool_files --modules
+ einstalldocs
+
+ if use sysv-utils; then
+ for app in halt poweroff reboot runlevel shutdown telinit; do
+ dosym "..${ROOTPREFIX-/usr}/bin/systemctl" /sbin/${app}
+ done
+ dosym "..${ROOTPREFIX-/usr}/lib/systemd/systemd" /sbin/init
+ else
+ # we just keep sysvinit tools, so no need for the mans
+ rm "${D}"/usr/share/man/man8/{halt,poweroff,reboot,runlevel,shutdown,telinit}.8 \
+ || die
+ rm "${D}"/usr/share/man/man1/init.1 || die
+ fi
+
+ # Disable storing coredumps in journald, bug #433457
+ mv "${D}"/usr/lib/sysctl.d/50-coredump.conf{,.disabled} || die
+
+ # Preserve empty dirs in /etc & /var, bug #437008
+ keepdir /etc/binfmt.d /etc/modules-load.d /etc/tmpfiles.d \
+ /etc/systemd/ntp-units.d /etc/systemd/user /var/lib/systemd \
+ /var/log/journal/remote
+
+ # Symlink /etc/sysctl.conf for easy migration.
+ dosym ../sysctl.conf /etc/sysctl.d/99-sysctl.conf
+
+ # If we install these symlinks, there is no way for the sysadmin to remove them
+ # permanently.
+ rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-networkd.service
+ rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-resolved.service
+ rm -f "${D}"/etc/systemd/system/multi-user.target.wants/systemd-timesyncd.service
+ rm -rf "${D}"/etc/systemd/system/network-online.target.wants
+
+ # Offer a default blacklist that should cover the most
+ # common use cases.
+ insinto /etc/modprobe.d
+ newins "${FILESDIR}"/blacklist-146 blacklist.conf
+}
+
+migrate_locale() {
+ local envd_locale_def="${EROOT%/}/etc/env.d/02locale"
+ local envd_locale=( "${EROOT%/}"/etc/env.d/??locale )
+ local locale_conf="${EROOT%/}/etc/locale.conf"
+
+ if [[ ! -L ${locale_conf} && ! -e ${locale_conf} ]]; then
+ # If locale.conf does not exist...
+ if [[ -e ${envd_locale} ]]; then
+ # ...either copy env.d/??locale if there's one
+ ebegin "Moving ${envd_locale} to ${locale_conf}"
+ mv "${envd_locale}" "${locale_conf}"
+ eend ${?} || FAIL=1
+ else
+ # ...or create a dummy default
+ ebegin "Creating ${locale_conf}"
+ cat > "${locale_conf}" <<-EOF
+ # This file has been created by the sys-apps/systemd ebuild.
+ # See locale.conf(5) and localectl(1).
+
+ # LANG=${LANG}
+ EOF
+ eend ${?} || FAIL=1
+ fi
+ fi
+
+ if [[ ! -L ${envd_locale} ]]; then
+ # now, if env.d/??locale is not a symlink (to locale.conf)...
+ if [[ -e ${envd_locale} ]]; then
+ # ...warn the user that he has duplicate locale settings
+ ewarn
+ ewarn "To ensure consistent behavior, you should replace ${envd_locale}"
+ ewarn "with a symlink to ${locale_conf}. Please migrate your settings"
+ ewarn "and create the symlink with the following command:"
+ ewarn "ln -s -n -f ../locale.conf ${envd_locale}"
+ ewarn
+ else
+ # ...or just create the symlink if there's nothing here
+ ebegin "Creating ${envd_locale_def} -> ../locale.conf symlink"
+ ln -n -s ../locale.conf "${envd_locale_def}"
+ eend ${?} || FAIL=1
+ fi
+ fi
+}
+
+migrate_net_name_slot() {
+ # If user has disabled 80-net-name-slot.rules using a empty file or a symlink to /dev/null,
+ # do the same for 80-net-setup-link.rules to keep the old behavior
+ local net_move=no
+ local net_name_slot_sym=no
+ local net_rules_path="${EROOT%/}"/etc/udev/rules.d
+ local net_name_slot="${net_rules_path}"/80-net-name-slot.rules
+ local net_setup_link="${net_rules_path}"/80-net-setup-link.rules
+ if [[ -e ${net_setup_link} ]]; then
+ net_move=no
+ elif [[ -f ${net_name_slot} && $(sed -e "/^#/d" -e "/^\W*$/d" ${net_name_slot} | wc -l) == 0 ]]; then
+ net_move=yes
+ elif [[ -L ${net_name_slot} && $(readlink ${net_name_slot}) == /dev/null ]]; then
+ net_move=yes
+ net_name_slot_sym=yes
+ fi
+ if [[ ${net_move} == yes ]]; then
+ ebegin "Copying ${net_name_slot} to ${net_setup_link}"
+
+ if [[ ${net_name_slot_sym} == yes ]]; then
+ ln -nfs /dev/null "${net_setup_link}"
+ else
+ cp "${net_name_slot}" "${net_setup_link}"
+ fi
+ eend $? || FAIL=1
+ fi
+}
+
+pkg_postinst() {
+ newusergroup() {
+ enewgroup "$1"
+ enewuser "$1" -1 -1 -1 "$1"
+ }
+
+ enewgroup input
+ enewgroup systemd-journal
+ newusergroup systemd-bus-proxy
+ newusergroup systemd-journal-gateway
+ newusergroup systemd-journal-remote
+ newusergroup systemd-journal-upload
+ newusergroup systemd-network
+ newusergroup systemd-resolve
+ newusergroup systemd-timesync
+ use http && newusergroup systemd-journal-gateway
+
+ systemd_update_catalog
+
+ # Keep this here in case the database format changes so it gets updated
+ # when required. Despite that this file is owned by sys-apps/hwids.
+ if has_version "sys-apps/hwids[udev]"; then
+ udevadm hwdb --update --root="${ROOT%/}"
+ fi
+
+ udev_reload || FAIL=1
+
+ # Bug 465468, make sure locales are respect, and ensure consistency
+ # between OpenRC & systemd
+ migrate_locale
+
+ # Migrate 80-net-name-slot.rules -> 80-net-setup-link.rules
+ migrate_net_name_slot
+
+ if [[ ${FAIL} ]]; then
+ eerror "One of the postinst commands failed. Please check the postinst output"
+ eerror "for errors. You may need to clean up your system and/or try installing"
+ eerror "systemd again."
+ eerror
+ fi
+
+ if [[ ! -L "${ROOT}"/etc/mtab ]]; then
+ ewarn "Upstream mandates the /etc/mtab file should be a symlink to /proc/mounts."
+ ewarn "Not having it is not supported by upstream and will cause tools like 'df'"
+ ewarn "and 'mount' to not work properly. Please run:"
+ ewarn " # ln -sf '${ROOT}proc/self/mounts' '${ROOT}etc/mtab'"
+ ewarn
+ fi
+
+ if [[ $(readlink "${ROOT}"/etc/resolv.conf) == */run/systemd/network/resolv.conf ]]; then
+ ewarn "resolv.conf is now generated by systemd-resolved. To use it, enable"
+ ewarn "systemd-resolved.service, and create a symlink from /etc/resolv.conf"
+ ewarn "to /run/systemd/resolve/resolv.conf"
+ ewarn
+ fi
+
+ if ! has_version sys-apps/systemd-ui; then
+ elog "To get additional features, a number of optional runtime dependencies may"
+ elog "be installed:"
+ elog "- sys-apps/systemd-ui: for GTK+ systemadm UI and gnome-ask-password-agent"
+ fi
+
+ if has_version sys-apps/openrc &&
+ ! has_version sys-fs/udev-init-scripts; then
+ elog "If you plan to boot using OpenRC and udev or eudev, you"
+ elog "need to install the udev-init-scripts package."
+ fi
+}
+
+pkg_prerm() {
+ # If removing systemd completely, remove the catalog database.
+ if [[ ! ${REPLACED_BY_VERSION} ]]; then
+ rm -f -v "${EROOT}"/var/lib/systemd/catalog/database
+ fi
+}